;; Time round!!         File:  round.lisp

(in-package '*lisp)

(*proclaim '(type single-float-pvar x))
(*defvar x (random!! (!! 256.0)))

(*proclaim '(type (signed-pvar 12) j))
(*defvar j (!! 0))

(defun test (n)
 (declare (type fixnum n))
 (cm:time (testx n))
)

(defun testx (n)
 (declare (type fixnum n))
 (dotimes (i n) (*set j (round!! x)))
)

;; Functions to examine selected portions of float representation

(*proclaim '(type fixnum a c d))

(defvar a 0)  (defvar c 0)  (defvar d 0)

;; Look at a CM float in x

(defun look (cube)
 (setq a (pvar-location x))
 (setq c (CM:add-offset-to-field-id a (- 23 8)))
 (setq d (CM:add-offset-to-field-id a 23))
 (list (pref j cube)
       (CM:u-read-from-processor-1L cube d 8)
       (CM:u-read-from-processor-1L cube c 8)
       (pref x cube))
)

;; Special function for rounding bounded single-float pvars
;; dest should have at least k bits.  Values in x should satisfy
;;
;;                  0 <= x < 2^k
;;
;; where k is a small integer >= 2.  The idea behind the function is to
;; use the standard Paris round with a small float field.

(*defun bsf-round (dest x k)
 (declare (type field-pvar dest) (type single-float-pvar x) (type fixnum k))
 (let ((df (pvar-location dest)) (xf (pvar-location x)) (sf 0) (sp (- 23 k)))
      (declare (type fixnum df xf sf sp))
   (*set dest (!! 0))
   (setq sf (CM:add-offset-to-field-id xf sp))
   (CM:u-f-round-2-2L df sf k k 8)
 )
)

;; Time bsf-round

(defun test2 (n k)
 (declare (type fixnum n k))
 (cm:time (test2x n k))
)

(defun test2x (n k)
 (declare (type fixnum n k))
 (dotimes (i n) (bsf-round j x k))
)

;; Timer for u-f-chop-2-2L.

(*proclaim '(type fixnum xloc jloc))

(defvar xloc 0) (defvar jloc 0)   ;; Pvar locations

(defun testc (n k)
 (declare (type fixnum n k))
 (*set x (random!! (!! (ash 1 k))))
 (*set j (!! 0))
 (setq xloc (pvar-location x))  (setq jloc (pvar-location j))
 (cm:time (testcx n k))
)

(defun testcx (n k)
 (declare (type fixnum n k))
 (dotimes (i n) (u-f-chop-2-2L jloc xloc k k 23 8))
)

;; Check chop result

(defun chkc ()
 (*when (/=!! j (floor!! x)) (*min (self-address!!)))
)
